src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface;
use Symfony\Component\Security\Core\User\UserInterface;
use App\Entity\Traits\VichUploadTrait;
use Vich\UploaderBundle\Mapping\Annotation as Vich;
use Symfony\Component\Validator\Constraints as Assert;


/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 * @Vich\Uploadable()
 * @ORM\Table(name="`user`")
 * @UniqueEntity(fields={"email"}, message="Il existe déjà un compte avec cet email")
 */
class User implements UserInterface, PasswordAuthenticatedUserInterface, \Serializable
{
    use VichUploadTrait;

    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $firstname;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $lastname;

    /**
     * @ORM\Column(type="string", length=180, unique=true)
     * @Assert\Email(message = "L'email '{{ value }}' n'est pas un email valide.")
     * @Assert\NotBlank()
     */
    private $email;

    /**
     * @ORM\Column(type="json")
     */
    private $roles = [];

    /**
     * @ORM\Column(type="boolean")
     */
    private $isVerified = false;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $phoneNumber;

    /**
     * @var string The hashed password
     * @ORM\Column(type="string")
     */
    private $password;

    /**
     * @ORM\ManyToOne(targetEntity=BetInvitationStatus::class)
     * @ORM\JoinColumn(nullable=true)
     */
    private $id_betInvitationStatus;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getFirstname(): ?string
    {
        return $this->firstname;
    }

    public function setFirstname(string $firstname): self
    {
        $this->firstname = $firstname;

        return $this;
    }

    public function getLastname(): ?string
    {
        return $this->lastname;
    }

    public function setLastname(string $lastname): self
    {
        $this->lastname = $lastname;

        return $this;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getUserIdentifier(): string
    {
        return (string) $this->email;
    }

    /**
     * @deprecated since Symfony 5.3, use getUserIdentifier instead
     */
    public function getUsername(): string
    {
        return (string) $this->email;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        $roles = $this->roles;
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function getSalt(): ?string
    {
        return null;
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        // $this->plainPassword = null;
    }

    public function isVerified(): bool
    {
        return $this->isVerified;
    }

    public function setIsVerified(bool $isVerified): self
    {
        $this->isVerified = $isVerified;

        return $this;
    }

    public function getPhoneNumber(): ?string
    {
        return $this->phoneNumber;
    }

    public function setPhoneNumber(?string $phoneNumber): self
    {
        $this->phoneNumber = $phoneNumber;

        return $this;
    }

    /**
     * @see PasswordAuthenticatedUserInterface
     */
    public function getPassword(): string
    {
        return $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    public function getIdBetInvitationStatus(): ?BetInvitationStatus
    {
        return $this->id_betInvitationStatus;
    }

    public function setIdBetInvitationStatus(?BetInvitationStatus $id_betInvitationStatus): self
    {
        $this->id_betInvitationStatus = $id_betInvitationStatus;

        return $this;
    }

    /** @see \Serializable::serialize() */
    public function serialize()
    {
        return serialize(array(
            $this->id,
            $this->email,
            $this->password
        ));
    }

    /** @see \Serializable::unserialize() */
    public function unserialize($serialized)
    {
        list (
            $this->id,
            $this->email,
            $this->password
        ) = unserialize($serialized);
    }




    
}

templates/base_admin.html.twig
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>{% block title %}Espace administrateur{% endblock %}</title>
    {# Run `composer require symfony/webpack-encore-bundle`
           and uncomment the following Encore helpers to start using Symfony UX #}
    {% block stylesheets %}
        {#{{ encore_entry_link_tags('app') }}#}
        <link href="{{ asset('build/app.css') }}" rel="stylesheet"/>
        <link href="{{ asset('Dynatable/jquery.dynatable.css') }}" rel="stylesheet"/>
        <link rel="stylesheet" media="all" href="https://s3.amazonaws.com/dynatable-docs-assets/css/bootstrap-2.3.2.min.css" />

        
    {% endblock %}

    {% block javascripts %}
        {#{{ encore_entry_script_tags('app') }}#}
        <script src="{{ asset('Dynatable/jquery-1.7.2.min.js') }}"></script>
        <script src="{{ asset('Dynatable/jquery.dynatable.js') }}"></script>
    {% endblock %}
</head>
<body>
    <nav>
        <div class="nav-admin">
            <img src='{{ asset('img/logo.png') }}' class="logo-admin-template"/>
            <p class="nav-title-admin">Espace administrateur</p>

            <ul class="nav-list-admin">
                <li><a href="#" class="nav-list-admin-links">Dashboard</a></li>              
                <li><a href="#" class="nav-list-admin-links">Statistiques</a></li>
                <li><a href="/admin/category/" class="nav-list-admin-links" {% if '/admin/category/' in app.request.uri %} style="text-decoration: underline;" {% endif %}>Catégories</a></li>
                <li><a href="/admin/event/" class="nav-list-admin-links" {% if '/admin/event/' in app.request.uri %} style="text-decoration: underline;" {% endif %}>Événements</a></li>
                <li><a href="#" class="nav-list-admin-links">Paris</a></li>
            </ul>
 
           
            <a href="/logout" class="logout-admin">Déconnexion</a>  
        </div>

    </nav>

    <div class="container-tpl container-tpl-admin">
        {% block body %}
        {% endblock %}
    </div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>

</body>
</html>

templates/base_back.html.twig
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <title>{% block title %}Welcome!{% endblock %}</title>
    {# Run `composer require symfony/webpack-encore-bundle`
           and uncomment the following Encore helpers to start using Symfony UX #}
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    {% block stylesheets %}
        {#{{ encore_entry_link_tags('app') }}#}
        <link href="{{ asset('build/app.css') }}" rel="stylesheet"/>
    {% endblock %}

    {% block javascripts %}
        {#{{ encore_entry_script_tags('app') }}#}
    {% endblock %}
</head>
<body>

<nav>

    {% if(is_granted('ROLE_ADMIN')) %}
        <a href="{{ path('back_default') }}">Admin</a>
    {% endif %}

</nav>
<div class="container">
    {% block body %}{% endblock %}
</div>
<script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
<script>
    {% for type, messages in app.flashes() %}
        {% for message in messages %}
            M.toast({html: '{{ message }}', classes: '{{ type }}'});
        {% endfor %}
    {% endfor %}
</script>
</body>
</html>

templates/base_front.html.twig
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    {% block stylesheets %}
        <link href="{{ asset('build/app.css') }}" rel="stylesheet"/>
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
        <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    {% endblock %}

    {% block javascripts %}
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
    {% endblock %}
</head>

<body>
    <header>
        <nav class="nav_front">
            <div class="nav-wrapper">
                <a href="#" class="brand-logo">
                    <img src="{{ asset('img/logo.png') }}" alt="logo anybet" class="logo-user-template">
                </a>
                <a href="#" data-target="mobile-demo" class="sidenav-trigger"><i class="material-icons">menu</i></a>
                <ul id="nav-mobile" class="right hide-on-med-and-down">

                    {% if is_granted('ROLE_USER') %} 
                    <li><a href="#category">Catégorie</a></li>
                    <li><a href="#create-bet">Création de paris</a></li>
                    <li><a href="#my-bets">Mes paris</a></li>
                    <li><a href="#my-wallet">Ma cagnotte</a></li>
                    <li>|</li>
                    <li><a href="{{ path('app_logout') }}">Se déconnecter</a></li>
                    <li><a href="{{ path('user_edit', {'id': app.user.id}) }}">Bonjour {{ app.user.username }}</a></li>
                    
                    {% else %}
                    <li><a href="#category">Catégorie</a></li>
                    <li><a href="#create-bet">Création de paris</a></li>
                    <li>|</li>
                    <li><a href="{{ path('app_register')}}">S'inscrire</a></li>
                    <li><a href="{{ path('app_login')}}">Se connecter</a></li>
                    {% endif %}
                </ul>
            </div>
          </nav>

          <ul class="sidenav" id="mobile-demo">
            <li><a href="#category">Catégorie</a></li>
            <li><a href="#create-bet">Création de paris</a></li>
            <li><a href="#my-bets">Mes paris</a></li>
            <li><a href="#my-wallet">Ma cagnotte</a></li>
            <li><a href="{{ path('app_register')}}">S'inscrire</a></li>
            <li><a href="{{ path('app_login')}}">Se connecter</a></li>
          </ul>
    </header>


    {% if  app.request.attributes.get('_route') == 'default' %}

        {{ form(form) }}

        {% if searchResultCat != null or searchResultEvent != null or searchResultBet != null %}
            <ul class="searchResults">
                {% if searchResultCat != null %}
                    <p class="searchResults-title">Catégories :</p>
                {% endif %}

                {% for result in searchResultCat %}
                        <li><a href="#">{{ result.name }}</a></li>
                {% endfor %}

                {% if searchResultEvent != null %}
                    <p class="searchResults-title">Événements :</p>
                {% endif %}
                
                {% for result in searchResultEvent %}
                    <li><a href="#">{{ result.name }}</a></li>

                {% endfor %}
                
                {% if searchResultBet != null %}
                    <p class="searchResults-title">Paris :</p>
                {% endif %}

                {% for result in searchResultBet %}
                    <li><a href="#">{{ result.name }}</a></li>
                {% endfor %}
            </ul>

        {% endif %}

    {% endif %}

    <div class="container">
        {% block body %}{% endblock %}
    </div>

    <script>
        
        $(document).ready(function(){
        $('.sidenav').sidenav();
        });
        {% for type, messages in app.flashes() %}
            {% for message in messages %}
                M.toast({html: '{{ message }}', classes: '{{ type }}'});
            {% endfor %}
        {% endfor %}
    </script>
</body>
</html>